"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_codegen_visitor_plugin_common_1 = require("graphql-codegen-visitor-plugin-common");
var autoBind = require("auto-bind");
var graphql_1 = require("graphql");
var typescript_variables_to_object_1 = require("./typescript-variables-to-object");
var TsVisitor = /** @class */ (function (_super) {
    __extends(TsVisitor, _super);
    function TsVisitor(pluginConfig, additionalConfig) {
        if (additionalConfig === void 0) { additionalConfig = {}; }
        var _this = _super.call(this, pluginConfig, __assign({ avoidOptionals: pluginConfig.avoidOptionals || false, maybeValue: pluginConfig.maybeValue || 'T | null', constEnums: pluginConfig.constEnums || false, enumsAsTypes: pluginConfig.enumsAsTypes || false, immutableTypes: pluginConfig.immutableTypes || false }, (additionalConfig || {})), null) || this;
        autoBind(_this);
        _this.setArgumentsTransformer(new typescript_variables_to_object_1.TypeScriptOperationVariablesToObject(_this.scalars, _this.convertName, _this.config.avoidOptionals, _this.config.immutableTypes));
        _this.setDeclarationBlockConfig({
            enumNameValueSeparator: ' ='
        });
        return _this;
    }
    TsVisitor.prototype.clearOptional = function (str) {
        if (str.startsWith('Maybe')) {
            return str.replace(/Maybe<(.*?)>/, '$1');
        }
        return str;
    };
    TsVisitor.prototype.NamedType = function (node) {
        return "Maybe<" + _super.prototype.NamedType.call(this, node) + ">";
    };
    TsVisitor.prototype.ListType = function (node) {
        return "Maybe<" + _super.prototype.ListType.call(this, node) + ">";
    };
    TsVisitor.prototype.wrapWithListType = function (str) {
        return (this.config.immutableTypes ? 'ReadonlyArray' : 'Array') + "<" + str + ">";
    };
    TsVisitor.prototype.NonNullType = function (node) {
        var baseValue = _super.prototype.NonNullType.call(this, node);
        return this.clearOptional(baseValue);
    };
    TsVisitor.prototype.FieldDefinition = function (node, key, parent) {
        var typeString = node.type;
        var originalFieldNode = parent[key];
        var addOptionalSign = !this.config.avoidOptionals && originalFieldNode.type.kind !== graphql_1.Kind.NON_NULL_TYPE;
        return graphql_codegen_visitor_plugin_common_1.indent("" + (this.config.immutableTypes ? 'readonly ' : '') + node.name + (addOptionalSign ? '?' : '') + ": " + typeString + ",");
    };
    TsVisitor.prototype.EnumTypeDefinition = function (node) {
        var _this = this;
        if (this.config.enumsAsTypes) {
            return new graphql_codegen_visitor_plugin_common_1.DeclarationBlock(this._declarationBlockConfig)
                .export()
                .asKind('type')
                .withName(this.convertName(node))
                .withContent(node.values.map(function (v) { return "'" + (_this.config.enumValues[v.name] || v.name) + "'"; }).join(' | ')).string;
        }
        else {
            return new graphql_codegen_visitor_plugin_common_1.DeclarationBlock(this._declarationBlockConfig)
                .export()
                .asKind(this.config.constEnums ? 'const enum' : 'enum')
                .withName(this.convertName(node))
                .withBlock(this.buildEnumValuesBlock(node.values)).string;
        }
    };
    return TsVisitor;
}(graphql_codegen_visitor_plugin_common_1.BaseTypesVisitor));
exports.TsVisitor = TsVisitor;
//# sourceMappingURL=visitor.js.map